#include "base.h"
#include "ctype.h"
#include "kprintf.h"
#include "stdlib.h"
#include "string.h"
#include "terminal.h"

#include <stdarg.h>
#include <stdint.h>

int print_int_base(int32_t number, const char *prefix, const char *base);

static int print_flag(char flag, va_list *ap)
{
	switch (flag) {
	case '%':
		return terminal_putchar('%');
	case 'i':
		return print_int_base(va_arg(*ap, int), NULL, BASE_DECA);
	case 'd':
		return print_int_base(va_arg(*ap, int), NULL, BASE_DECA);
	case 'c':
		return terminal_putchar(va_arg(*ap, int));
	case 's':
		return terminal_writestring(va_arg(*ap, char *));
	case 'p':
		return print_int_base(va_arg(*ap, int), "0x", BASE_HEXA);
	case 'x':
		return print_int_base(va_arg(*ap, int), "0x", BASE_HEXA);
	case 'u':
		return print_int_base(va_arg(*ap, uint32_t), NULL, BASE_DECA);
	}
	return 0;
}

int kvprintf(int level, const char *restrict format, va_list ap)
{
	const char *start = format;
	int ret = 0;

	(void)level;
	while (*start != '\0') {
		if (*start == '%' && *(start + 1) != '\0') {
			ret += print_flag(*(start + 1), &ap);
			start++;
		} else {
			ret += terminal_putchar(*start);
		}
		start++;
	}
	update_cursor();
	return ret;
}
